// rotulo.cc
#include <stdio.h>
#include <string.h>
#include "rotulo.h"
#include "global.h"

typedef void (*fdraw)(Widget w, int ancho, int alto, void *t);
const int CaracteresDeAnchura=40;

int Rotulo::anchura(char *s)
{
  return   XTextWidth(chf, s,strlen(s));
}
 
GC Rotulo::setup_gc()
{
  int fore_g,back_g;      /* Fore and back ground pixels */
  GC  drawgc;

  back_g = WhitePixel(XtDisplay(w),DefaultScreen(XtDisplay(w)));
  fore_g = BlackPixel(XtDisplay(w),DefaultScreen(XtDisplay(w)));

  /* Create drawing GC */
  drawgc = XCreateGC(XtDisplay(w), DefaultRootWindow(XtDisplay(w)), 0, 0);

  XSetBackground(XtDisplay(w), drawgc, back_g);
  XSetForeground(XtDisplay(w), drawgc, fore_g);
  XSetFunction(XtDisplay(w),   drawgc, GXcopy);

  return drawgc;
} /* end of setup_gc() */



void Rotulo::static_dibujarRotulo(Widget,int ancho, int alto, Rotulo *t)
{
  t->dibujarRotulo(ancho,alto);
}

void Rotulo::Draw(GC gc,char *rotulo)
{
  XDrawImageString(XtDisplay(w), (Window)XtWindow(w), gc, 10, FontHeight(chf)*3/2,
                   rotulo,strlen((char *)rotulo));
}

void Rotulo::dibujarRotulo(int /*ancho*/, int /*alto*/)
{
GC gc=setup_gc();

  borrar();
  XSetFont(XtDisplay(w),gc,chf->fid);
  if(rotulo)
  Draw(gc,rotulo);
  XFreeGC(XtDisplay(w),gc);
}


Rotulo::Rotulo(char *fuente,int es_16)
{
  int anchura,altura;

  ponerFuente(fuente);  
  anchura=TextWidth(chf,"x")*CaracteresDeAnchura;
  if(es_16) anchura /=2;
  altura=FontHeight(chf)*2;
  w = MakeDrawArea(anchura,altura,(fdraw)static_dibujarRotulo,this);
  rotulo=0;
}

void Rotulo::ponerFuente(char *fuente)
{
char buffer[500];

  chf=GetFont(fuente);
  if(chf==NULL)
  {  
    if(strlen(fuente)>=499) fuente[499]=0;

    sprintf(buffer,S_22,fuente);
    GetYesNo(buffer);
    exit(0);
  }

}

void Rotulo::borrar()
{
  SetDrawArea(w);
  ClearDrawArea();
}

void Rotulo::escribir(char *s)
{
  rotulo = s;
  dibujarRotulo(10,10);
}

Rotulo::~Rotulo()
{
  FreeFont(chf);
}
